#ifndef QTGPSMM_H
#define QTGPSMM_H

#include <iostream>
#include <inttypes.h>
#include "qobject.h"
#include "qstring.h"
#include "qstrlist.h"
#include "qdatetime.h"
#include "qsocketnotifier.h"
#include "gps.h"

class qtGpsd : public QObject
{
    
    Q_OBJECT
    
public:
    
    QString buffer;
    int level;
    
    qtGpsd();
    
    bool gps_connect(const char *host = "localhost",const char *port = "2947");
    
    void gps_disconnect();
    
    bool isConnected() {
        return (gps_data != 0);
    }
    
    QStrList getDeviceList();
    
    char* getCurrentDevice();
    
    void setCurrentDevice(const char* device);
    
    double fixTime() { return gps_data ? gps_data->fix.time : 0; }
    
    QString fixISOTime();
    
    const char *gpsId() { return gps_data ? gps_data->gps_id : ""; }
    
    const struct gps_data_t *getGpsData() { return gps_data; }
    
    void setJitter(bool s);
    
signals:
    void dataReceived();
    void deviceChanged();
    void deviceListChanged();
    
protected:
    struct gps_data_t *gps_data;
    QSocketNotifier *readNotify;
    
    static void callback(struct gps_data_t* p, char* buf, size_t len, int level);
    
protected slots:
    void handleInput(int socket);
};

#endif // MAINFORM_H
